Index: gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE.sh	(revision 28192)
+++ gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE.sh	(revision 28194)
@@ -2,5 +2,5 @@
 
 
-for d in APR SQLITE APRUTIL OPENSSL SERF NEON ZLIB SUBVERSION ; do
+for d in LIBXML APR SQLITE APRUTIL OPENSSL SERF ZLIB SUBVERSION ; do
   echo "    Running CASCADE-MAKE/$d.sh $*"
 
Index: gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/LIBXML.sh
===================================================================
--- gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/LIBXML.sh	(revision 28194)
+++ gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/LIBXML.sh	(revision 28194)
@@ -0,0 +1,24 @@
+#!/bin/bash
+
+# libxml2.2.9.0 was modified for Greenstone to allow compilation to succeed on a Mac, so it has acquired a 'gs-' prefix
+package=gs-libxml2
+version=-2.9.0
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXTSVN ../.. $*
+
+prefix=$GEXTSVN_INSTALLED
+
+export CFLAGS="$CFLAGS -DLIBXML_STATIC"
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version $prefix \
+  --without-python
+
+opt_run_make $compile $package $version
+opt_run_make $install $package $version "install"
+opt_run_make $clean $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
Index: gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SERF.sh
===================================================================
--- gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SERF.sh	(revision 28192)
+++ gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SERF.sh	(revision 28194)
@@ -2,5 +2,5 @@
 
 package=serf
-version=-0.3.0
+version=-1.3.1
 
 progname=$0
@@ -10,15 +10,33 @@
 prefix=$GEXTSVN_INSTALLED
 
-export CFLAGS="-fPIC -I$prefix/include $CFLAGS"
-export CXXFLAGS="-fPIC -I$prefix/include $CXXFLAGS"
-export CPPFLAGS="-fPIC -I$prefix/include $CPPFLAGS"
-export LDFLAGS="-L$prefix/lib $LDFLAGS"
+#export CFLAGS="-fPIC -I$prefix/include $CFLAGS"
+#export CXXFLAGS="-fPIC -I$prefix/include $CXXFLAGS"
+#export CPPFLAGS="-fPIC -I$prefix/include $CPPFLAGS"
+#export LDFLAGS="-L$prefix/lib $LDFLAGS"
 
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_configure $force_config $auto_config $package $version $prefix
+opt_run_untar $force_untar $auto_untar $package $version .tar.bz2
+if [ ! -f $package$version/scons.py ] ; then
+  /bin/cp scons-local-2.3.0.tar.gz $package$version/. \
+  && (cd $package$version ; tar xvzf scons-local-2.3.0.tar.gz )
+fi
 
-opt_run_make $compile   $package $version
-opt_run_make $install   $package $version "install"
-opt_run_make $clean     $package $version "clean"
+#opt_run_configure $force_config $auto_config $package $version $prefix
+
+#opt_run_make $compile   $package $version
+if [ $compile = 1 ] ; then
+  (cd $package$version ; ./scons.py APR=$prefix APU=$prefix OPENSSL=$prefix PREFIX=$prefix)
+fi
+
+#opt_run_make $install   $package $version "install"
+if [ $compile = 1 ] ; then
+  (cd $package$version ; ./scons.py install)
+fi
+
+#opt_run_make $clean     $package $version "clean"
+if [ $compile = 1 ] ; then
+  (cd $package$version ; ./scons.py -c)
+fi
+
+
 opt_run_make $distclean $package $version "distclean"
 
Index: gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SQLITE.sh
===================================================================
--- gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SQLITE.sh	(revision 28192)
+++ gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SQLITE.sh	(revision 28194)
@@ -2,5 +2,5 @@
 
 package=sqlite
-version=-3.7.2
+version=-3.7.17
 
 progname=$0
@@ -11,5 +11,5 @@
 
 opt_run_untar $force_untar $auto_untar $package $version
-opt_run_configure $force_config $auto_config $package $version $prefix
+opt_run_configure $force_config $auto_config $package $version $prefix --disable-tcl
 
 opt_run_make $compile   $package $version
Index: gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SUBVERSION.sh
===================================================================
--- gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SUBVERSION.sh	(revision 28192)
+++ gs2-extensions/subversion/trunk/src/packages/CASCADE-MAKE/SUBVERSION.sh	(revision 28194)
@@ -2,5 +2,5 @@
 
 package=subversion
-version=-1.6.13
+version=-1.8.1
 
 progname=$0
@@ -16,5 +16,7 @@
 
 opt_run_untar $force_untar $auto_untar $package $version
-opt_run_configure $force_config $auto_config $package $version $prefix --with-sqlite=$prefix
+opt_run_configure $force_config $auto_config $package $version $prefix \
+  --with-sqlite=$prefix \
+  --with-serf=$prefix
 
 opt_run_make $compile   $package $version