Index: /main/trunk/model-sites-dev/pei-jones/collect/photos/etc/collectionConfig.xml
===================================================================
--- /main/trunk/model-sites-dev/pei-jones/collect/photos/etc/collectionConfig.xml	(revision 28245)
+++ /main/trunk/model-sites-dev/pei-jones/collect/photos/etc/collectionConfig.xml	(revision 28246)
@@ -309,5 +309,5 @@
 									</xsl:text>
 										<xsl:choose>
-											<xsl:when test="/page/pageRequest/userInformation/@username">
+											<xsl:when test="/page/pageRequest/userInformation/@username and /page/pageRequest/userInformation/@editEnabled = 'true'">
 												<xsl:text disable-output-escaping="yes">editable: true,</xsl:text>
 											</xsl:when>
Index: /main/trunk/model-sites-dev/pei-jones/collect/photos/script/image-annotator/js/jquery.annotate2.js
===================================================================
--- /main/trunk/model-sites-dev/pei-jones/collect/photos/script/image-annotator/js/jquery.annotate2.js	(revision 28245)
+++ /main/trunk/model-sites-dev/pei-jones/collect/photos/script/image-annotator/js/jquery.annotate2.js	(revision 28246)
@@ -175,8 +175,9 @@
 	**/
     $.fn.annotateImage.add = function(image) {
-        
 		console.log("image mode = " + image.mode);
         if (image.mode == 'view') {
             image.mode = 'edit';
+			
+			gs.userInformation.currentAction = "editingNote";
 
             // Create/prepare the editable note elements
@@ -196,5 +197,5 @@
 
         ok.click(function() {
-						
+			gs.userInformation.currentAction = "savingNote";
             var form = $('#image-annotate-edit-form form');
             var text = $('#image-annotate-text').val();
Index: /main/trunk/model-sites-dev/pei-jones/transform/layouts/header.xsl
===================================================================
--- /main/trunk/model-sites-dev/pei-jones/transform/layouts/header.xsl	(revision 28245)
+++ /main/trunk/model-sites-dev/pei-jones/transform/layouts/header.xsl	(revision 28246)
@@ -63,5 +63,5 @@
 				$(window).load(function()
 				{
-					if(gs.cgiParams.d != undefined &amp;&amp; gs.userInformation != undefined)
+					if(gs.cgiParams.d &amp;&amp; gs.userInformation &amp;&amp; gs.userInformation.editEnabled == "true")
 					{
 						var statusBarDiv = $("&lt;div&gt;");
@@ -70,11 +70,25 @@
 						var statusUsernameMap = new Array();
 						
-						var recordURL = gs.xsltParams.library_name + "?a=g&amp;rt=ro&amp;s=RecordUserAction&amp;s1.site=" + gs.xsltParams.site_name + "&amp;s1.collection=" + gs.cgiParams.c + "&amp;s1.oid=" + gs.cgiParams.d + "&amp;s1.username=" + gs.userInformation.username + "&amp;s1.action=viewingPage";
-						var recordActionFunction = function(url)
+						var recordActionFunction = function()
 						{
-							$.ajax(url);
+							var action = gs.userInformation.currentAction;
+							if(!action)
+							{
+								action = "viewingPage";
+							}
+							$.ajax(gs.xsltParams.library_name + "?a=g&amp;rt=ro&amp;s=RecordUserAction&amp;s1.site=" + gs.xsltParams.site_name + "&amp;s1.collection=" + gs.cgiParams.c + "&amp;s1.oid=" + gs.cgiParams.d + "&amp;s1.username=" + gs.userInformation.username + "&amp;s1.action=" + action);
+
+							if(action == "savingNote" &amp;&amp; gs.userInformation.saveSentOnce)
+							{
+								gs.userInformation.currentAction = "viewingPage";
+								gs.userInformation.saveSentOnce = false;
+							}
+							else if(action == "savingNote")
+							{
+								gs.userInformation.saveSentOnce = true;
+							}
 						}
-						setInterval(function(){recordActionFunction(recordURL);}, 5000);
-						recordActionFunction(recordURL);
+						setInterval(recordActionFunction, 5000);
+						recordActionFunction();
 		
 						var userTrackerFunction = function(url)
@@ -93,9 +107,28 @@
 									}
 
+									var statusString;
 									if($(this).attr("action") == "viewingPage")
 									{
-										var statusID = statusBar.addStatus("User " + $(this).attr("username") + " is currently viewing this page");
+										statusString = "User " + $(this).attr("username") + " is currently viewing this page";
 									}
-									statusUsernameMap[username] = statusID;
+									else if($(this).attr("action") == "addingNote")
+									{
+										statusString = "User " + $(this).attr("username") + " is currently adding a note";
+									}
+									else if($(this).attr("action") == "editingNote")
+									{
+										statusString = "User " + $(this).attr("username") + " is currently editing a note";
+									}
+									else if($(this).attr("action") == "savingNote")
+									{
+										gs.userInformation.reloadRequired = true;
+										statusString = "User " + $(this).attr("username") + " has saved a note";
+									}
+
+									if(gs.userInformation.reloadRequired)
+									{
+										statusString += ", a note has been added or changed, please click &lt;a href=\"javascript:location.reload();\"&gt;here&lt;/a&gt; to reload the page";
+									}
+									statusBar.addStatus(statusString);
 								});
 							});
Index: /main/trunk/model-sites-dev/pei-jones/transform/pages/document.xsl
===================================================================
--- /main/trunk/model-sites-dev/pei-jones/transform/pages/document.xsl	(revision 28245)
+++ /main/trunk/model-sites-dev/pei-jones/transform/pages/document.xsl	(revision 28246)
@@ -149,10 +149,10 @@
 					<script type="text/javascript" src="interfaces/{$interface_name}/js/direct-edit.js"><xsl:text> </xsl:text></script>
 					<xsl:call-template name="init-direct-edit"/>
-					<xsl:if test="metadataList/metadata[@name='dc.Title'] or metadataList/metadata[@name='dc.Subject'] or /page/pageRequest/userInformation">
+					<xsl:if test="metadataList/metadata[@name='dc.Title'] or metadataList/metadata[@name='dc.Subject'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
 						<table id="meta{@nodeID}" style="width:100%;">
-							<xsl:if test="metadataList/metadata[@name='dc.Title'] or /page/pageRequest/userInformation">
+							<xsl:if test="metadataList/metadata[@name='dc.Title'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
 								<tr>
 									<xsl:choose>
-										<xsl:when test="/page/pageRequest/userInformation">
+										<xsl:when test="(/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
 											<td style="width:25%;" class="metaTableCellName">dc.Title</td>
 										</xsl:when>
@@ -173,8 +173,8 @@
 								</tr>
 							</xsl:if>
-							<xsl:if test="metadataList/metadata[@name='dc.Subject'] or /page/pageRequest/userInformation">
+							<xsl:if test="metadataList/metadata[@name='dc.Subject'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
 								<tr>
 									<xsl:choose>
-										<xsl:when test="/page/pageRequest/userInformation">
+										<xsl:when test="(/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
 											<td style="width:25%;" class="metaTableCellName">dc.Subject</td>
 										</xsl:when>
@@ -197,5 +197,5 @@
 						</table>
 					</xsl:if>
-					<xsl:if test="/page/pageRequest/userInformation">
+					<xsl:if test="/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true'">
 						<button id="quickSaveButton">Save Changes</button>
 						<script type="text/javascript">