Index: main/trunk/model-sites-dev/pei-jones/collect/photos/transform/pages/document.xsl
===================================================================
--- main/trunk/model-sites-dev/pei-jones/collect/photos/transform/pages/document.xsl	(revision 28262)
+++ main/trunk/model-sites-dev/pei-jones/collect/photos/transform/pages/document.xsl	(revision 28262)
@@ -0,0 +1,239 @@
+<?xml version="1.0" encoding="UTF-8"?><xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat" xmlns:gslib="http://www.greenstone.org/skinning" xmlns:java="http://xml.apache.org/xslt/java" xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil" exclude-result-prefixes="java util gsf" extension-element-prefixes="java util" version="1.0">
+
+	<xsl:template name="customImageFileDownload">
+					<div class="ui-state-default ui-corner-all" style="margin:5px;">
+						<!-- Add image file download button -->
+						<xsl:variable name="assocfilepath">
+							<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/document/metadataList/metadata[@name = 'assocfilepath']"/>
+						</xsl:variable>
+						<xsl:variable name="image_file">
+							<xsl:value-of disable-output-escaping="yes" select="(.//metadataList)[last()]/metadata[@name = 'Source']"/>
+						</xsl:variable>
+						
+						<a id="btnDownloadImage" style="padding: 3px; text-decoration: none;">
+							<xsl:attribute name="href">
+								<xsl:text>cgi-bin/file-download.pl?filename=</xsl:text>
+								<xsl:value-of select="$image_file"/>
+								<xsl:text>&amp;site=localsite&amp;c=pjpaged&amp;assoc=</xsl:text>
+								<xsl:value-of select="$assocfilepath"/>
+							</xsl:attribute>
+							Download Image File
+						</a>
+					</div>
+	</xsl:template>
+
+	<xsl:template name="editBar">
+		<table style="width:100%"><tr>
+			<td id="editBarLeft" style="width:70%"><xsl:text> </xsl:text></td>
+			<td id="editBarRight">
+				<div style="text-align:center;">
+					<div class="ui-state-default ui-corner-all" style="margin:5px;">
+						<a href="{$library_name}?a=g&amp;sa=documentbasket&amp;c=&amp;s=DisplayDocumentList&amp;rt=r&amp;p.c={/page/pageResponse/collection/@name}&amp;docToEdit={/page/pageResponse/document/documentNode/@nodeID}" style="padding: 3px; text-decoration:none;"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.edit_structure')"/></a>
+					</div>
+					<div class="ui-state-default ui-corner-all" style="margin:5px;">
+						<a id="editContentButton" style="padding: 3px; text-decoration:none;">
+							<xsl:attribute name="href">
+								<xsl:value-of select="$library_name"/>
+								<xsl:text>/collection/</xsl:text>
+								<xsl:value-of select="$collName"/>
+								<xsl:text>/document/</xsl:text>
+								<xsl:choose>
+									<xsl:when test="count(//documentNode) &gt; 0">
+										<xsl:value-of select="/page/pageResponse/document/documentNode/@nodeID"/>
+									</xsl:when>
+									<xsl:otherwise>
+										<xsl:value-of select="/page/pageResponse/document/@nodeID"/>
+									</xsl:otherwise>
+								</xsl:choose>
+								<xsl:if test="not(/page/pageRequest/paramList/param[@name = 'docEdit']/@value = '1')">
+									<xsl:text>?ed=1&amp;docEdit=1&amp;dt=hierarchy</xsl:text>
+								</xsl:if>
+							</xsl:attribute>
+							<xsl:choose>
+								<xsl:when test="/page/pageRequest/paramList/param[@name = 'docEdit']/@value = '1'">
+									<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.hide_editor')"/>
+								</xsl:when>
+								<xsl:otherwise>
+									<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.edit_content')"/>
+								</xsl:otherwise>
+							</xsl:choose>
+						</a>
+					</div>
+					<xsl:call-template name="customImageFileDownload"/>
+				</div>
+			</td>
+		</tr></table>
+		<gslib:langfrag name="dse"/>
+	</xsl:template>
+	
+	<xsl:template name="wrappedSectionImage">
+		<xsl:call-template name="UserTrackerScripts"/>
+
+		<gsf:variable name="screenImageWidth"><gsf:metadata name="ScreenWidth"/></gsf:variable>
+		<gsf:variable name="screenImageHeight"><gsf:metadata name="ScreenHeight"/></gsf:variable>
+		<gsf:variable name="imageWidth"><gsf:metadata name="ImageWidth"/></gsf:variable>
+		<gsf:variable name="imageHeight"><gsf:metadata name="ImageHeight"/></gsf:variable>
+
+		<xsl:choose>
+			<xsl:when test="metadataList/metadata[@name = 'Screen'] and metadataList/metadata[@name = 'SourceFile'] and ($imageWidth div $screenImageWidth &gt; 1.2)  and (not(/page/pageResponse/format[@type='display']/gsf:option[@name='disableZoom']) or /page/pageResponse/format[@type='display']/gsf:option[@name='disableZoom']/@value='false')">
+				<div id="image{@nodeID}">
+					<div class="zoomImage" id="wrap{util:replace(@nodeID, '.', '_')}" style="position:relative; width: {$screenImageWidth}px; height: {$screenImageHeight}px;">
+						<div id="small{util:replace(@nodeID, '.', '_')}" style="position:relative; width: {$screenImageWidth}px; height: {$screenImageHeight}px;">
+							<!--<gsf:image type="screen"/>-->
+							<xsl:call-template name="customScreenImage"/>
+						</div>
+						<div id="mover{util:replace(@nodeID, '.', '_')}" style="border: 1px solid green; position: absolute; top: 0; left: 0; width: 598px; height: 598px; overflow: hidden; z-index: 100; background: white; display: none;">
+							<div id="overlay{util:replace(@nodeID, '.', '_')}" style="width: 600px; height: 600px; position: absolute; top: 0; left: 0; z-index: 200;">
+								<xsl:text> </xsl:text>
+							</div>
+							<div id="large{util:replace(@nodeID, '.', '_')}" style="position: relative; width: {$imageWidth}px; height: {$imageHeight}px;">
+								<gsf:image type="source"/>
+							</div>
+						</div>
+					</div>
+					<script type="text/javascript">
+						<xsl:text disable-output-escaping="yes">
+							{
+								var nodeID = "</xsl:text><xsl:value-of select="@nodeID"/><xsl:text disable-output-escaping="yes">";
+								nodeID = nodeID.replace(/\./g, "_");
+
+								var bigHeight = </xsl:text><xsl:value-of select="$imageHeight"/><xsl:text disable-output-escaping="yes">;
+								var smallHeight = </xsl:text><xsl:value-of select="$screenImageHeight"/><xsl:text disable-output-escaping="yes">;
+
+								var multiplier = bigHeight / smallHeight;
+
+								$("#wrap" + nodeID).anythingZoomer({
+									smallArea: "#small" + nodeID,
+									largeArea: "#large" + nodeID,
+									zoomPort: "#overlay" + nodeID,
+									mover: "#mover" + nodeID,
+									expansionSize:50,  
+									speedMultiplier:multiplier   
+								});
+
+								$("#zoomOptions input").attr("checked", false);
+								$("#zoomOptions").css("display", null);
+							}
+						</xsl:text>
+					</script>
+				</div>
+			</xsl:when>
+			<xsl:otherwise>
+				<!-- this is where -->
+				<div id="image{@nodeID}">
+					<xsl:attribute name="style">
+						<xsl:choose>
+							<xsl:when test="/page/pageRequest/paramList/param[@name = 'view']/@value = 'text'">
+								<xsl:text>display:none;</xsl:text>
+							</xsl:when>
+							<xsl:otherwise>
+								<xsl:text>display:block;</xsl:text>
+							</xsl:otherwise>
+						</xsl:choose>
+						<xsl:text>float:left;</xsl:text>
+					</xsl:attribute>
+					<xsl:call-template name="sectionImage"/>
+					<xsl:text> </xsl:text>
+				</div>
+				<div style="float:right; width:50%; margin-right:50px;">
+					<xsl:variable name="editable">
+						<xsl:choose>
+							<xsl:when test="/page/pageRequest/userInformation">
+								<xsl:text>editable</xsl:text>
+							</xsl:when>
+							<xsl:otherwise>
+								<xsl:text> </xsl:text>
+							</xsl:otherwise>
+						</xsl:choose>
+					</xsl:variable>
+					<script type="text/javascript" src="interfaces/{$interface_name}/js/direct-edit.js"><xsl:text> </xsl:text></script>
+					<xsl:call-template name="init-direct-edit"/>
+					<xsl:if test="metadataList/metadata[@name='dc.Title'] or metadataList/metadata[@name='dc.Subject'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
+						<table id="meta{@nodeID}" style="width:100%;">
+							<xsl:if test="metadataList/metadata[@name='dc.Title'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
+								<tr>
+									<xsl:choose>
+										<xsl:when test="(/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
+											<td style="width:25%;" class="metaTableCellName">dc.Title</td>
+										</xsl:when>
+										<xsl:otherwise>
+											<td style="width:25%;" class="metaTableCellName">Title</td>
+										</xsl:otherwise>
+									</xsl:choose>
+									<td class="metaTableCell {$editable}">
+										<xsl:choose>
+											<xsl:when test="metadataList/metadata[@name='dc.Title']">
+												<xsl:value-of disable-output-escaping="yes" select="metadataList/metadata[@name='dc.Title']"/>
+											</xsl:when>
+											<xsl:otherwise>
+												<xsl:text>[No Title]</xsl:text>
+											</xsl:otherwise>
+										</xsl:choose>
+									</td>
+								</tr>
+							</xsl:if>
+							<xsl:if test="metadataList/metadata[@name='dc.Subject'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
+								<tr>
+									<xsl:choose>
+										<xsl:when test="(/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
+											<td style="width:25%;" class="metaTableCellName">dc.Subject</td>
+										</xsl:when>
+										<xsl:otherwise>
+											<td style="width:25%;" class="metaTableCellName">Subject</td>
+										</xsl:otherwise>
+									</xsl:choose>
+									<td class="metaTableCell {$editable}">
+										<xsl:choose>
+											<xsl:when test="metadataList/metadata[@name='dc.Subject']">
+												<xsl:value-of disable-output-escaping="yes" select="metadataList/metadata[@name='dc.Subject']"/>
+											</xsl:when>
+											<xsl:otherwise>
+												<xsl:text>[No Subject]</xsl:text>
+											</xsl:otherwise>
+										</xsl:choose>
+									</td>
+								</tr>
+							</xsl:if>
+						</table>
+					</xsl:if>
+					<xsl:if test="/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true'">
+						<button id="quickSaveButton">Save Changes</button>
+						<script type="text/javascript">
+							<xsl:text disable-output-escaping="yes">
+								$(window).load(function()
+								{
+									$("#quickSaveButton").click(save);
+								});
+							</xsl:text>
+						</script>
+					</xsl:if>
+				</div>
+				<div style="clear:both;"><xsl:text> </xsl:text></div>
+			</xsl:otherwise>
+		</xsl:choose>
+	</xsl:template>
+	
+	<!-- custom screen image template so we can add "toAnnotate" class to each paged image-->
+	<xsl:template name="customScreenImage" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+		
+		<gsf:variable name="screenImageWidth" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"><gsf:metadata name="ScreenWidth"/></gsf:variable>
+		<gsf:variable name="screenImageHeight" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"><gsf:metadata name="ScreenHeight"/></gsf:variable>
+		<gsf:variable name="imageWidth" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"><gsf:metadata name="ImageWidth"/></gsf:variable>
+		<gsf:variable name="imageHeight" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"><gsf:metadata name="ImageHeight"/></gsf:variable>
+
+		<xsl:variable name="ScreenName">Screen</xsl:variable>
+		
+		<gsf:link type="source">
+		  <img style="border: 1px solid #000;">
+			<xsl:attribute name="src">
+				<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
+				<xsl:text>/index/assoc/</xsl:text>
+				<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/document/metadataList/metadata[@name = 'assocfilepath']"/>
+				<xsl:text>/</xsl:text>
+				<xsl:value-of disable-output-escaping="yes" select="(.//metadataList)[last()]/metadata[@name = $ScreenName]"/>
+			</xsl:attribute>
+		  </img>
+		</gsf:link>
+	</xsl:template>
+
+</xsl:stylesheet>
Index: main/trunk/model-sites-dev/pei-jones/transform/pages/document.xsl
===================================================================
--- main/trunk/model-sites-dev/pei-jones/transform/pages/document.xsl	(revision 28261)
+++ 	(revision )
@@ -1,239 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?><xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat" xmlns:gslib="http://www.greenstone.org/skinning" xmlns:java="http://xml.apache.org/xslt/java" xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil" exclude-result-prefixes="java util gsf" extension-element-prefixes="java util" version="1.0">
-
-	<xsl:template name="customImageFileDownload">
-					<div class="ui-state-default ui-corner-all" style="margin:5px;">
-						<!-- Add image file download button -->
-						<xsl:variable name="assocfilepath">
-							<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/document/metadataList/metadata[@name = 'assocfilepath']"/>
-						</xsl:variable>
-						<xsl:variable name="image_file">
-							<xsl:value-of disable-output-escaping="yes" select="(.//metadataList)[last()]/metadata[@name = 'Source']"/>
-						</xsl:variable>
-						
-						<a id="btnDownloadImage" style="padding: 3px; text-decoration: none;">
-							<xsl:attribute name="href">
-								<xsl:text>cgi-bin/file-download.pl?filename=</xsl:text>
-								<xsl:value-of select="$image_file"/>
-								<xsl:text>&amp;site=localsite&amp;c=pjpaged&amp;assoc=</xsl:text>
-								<xsl:value-of select="$assocfilepath"/>
-							</xsl:attribute>
-							Download Image File
-						</a>
-					</div>
-	</xsl:template>
-
-	<xsl:template name="editBar">
-		<table style="width:100%"><tr>
-			<td id="editBarLeft" style="width:70%"><xsl:text> </xsl:text></td>
-			<td id="editBarRight">
-				<div style="text-align:center;">
-					<div class="ui-state-default ui-corner-all" style="margin:5px;">
-						<a href="{$library_name}?a=g&amp;sa=documentbasket&amp;c=&amp;s=DisplayDocumentList&amp;rt=r&amp;p.c={/page/pageResponse/collection/@name}&amp;docToEdit={/page/pageResponse/document/documentNode/@nodeID}" style="padding: 3px; text-decoration:none;"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.edit_structure')"/></a>
-					</div>
-					<div class="ui-state-default ui-corner-all" style="margin:5px;">
-						<a id="editContentButton" style="padding: 3px; text-decoration:none;">
-							<xsl:attribute name="href">
-								<xsl:value-of select="$library_name"/>
-								<xsl:text>/collection/</xsl:text>
-								<xsl:value-of select="$collName"/>
-								<xsl:text>/document/</xsl:text>
-								<xsl:choose>
-									<xsl:when test="count(//documentNode) &gt; 0">
-										<xsl:value-of select="/page/pageResponse/document/documentNode/@nodeID"/>
-									</xsl:when>
-									<xsl:otherwise>
-										<xsl:value-of select="/page/pageResponse/document/@nodeID"/>
-									</xsl:otherwise>
-								</xsl:choose>
-								<xsl:if test="not(/page/pageRequest/paramList/param[@name = 'docEdit']/@value = '1')">
-									<xsl:text>?ed=1&amp;docEdit=1&amp;dt=hierarchy</xsl:text>
-								</xsl:if>
-							</xsl:attribute>
-							<xsl:choose>
-								<xsl:when test="/page/pageRequest/paramList/param[@name = 'docEdit']/@value = '1'">
-									<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.hide_editor')"/>
-								</xsl:when>
-								<xsl:otherwise>
-									<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.edit_content')"/>
-								</xsl:otherwise>
-							</xsl:choose>
-						</a>
-					</div>
-					<xsl:call-template name="customImageFileDownload"/>
-				</div>
-			</td>
-		</tr></table>
-		<gslib:langfrag name="dse"/>
-	</xsl:template>
-	
-	<xsl:template name="wrappedSectionImage">
-		<xsl:call-template name="UserTrackerScripts"/>
-
-		<gsf:variable name="screenImageWidth"><gsf:metadata name="ScreenWidth"/></gsf:variable>
-		<gsf:variable name="screenImageHeight"><gsf:metadata name="ScreenHeight"/></gsf:variable>
-		<gsf:variable name="imageWidth"><gsf:metadata name="ImageWidth"/></gsf:variable>
-		<gsf:variable name="imageHeight"><gsf:metadata name="ImageHeight"/></gsf:variable>
-
-		<xsl:choose>
-			<xsl:when test="metadataList/metadata[@name = 'Screen'] and metadataList/metadata[@name = 'SourceFile'] and ($imageWidth div $screenImageWidth &gt; 1.2)  and (not(/page/pageResponse/format[@type='display']/gsf:option[@name='disableZoom']) or /page/pageResponse/format[@type='display']/gsf:option[@name='disableZoom']/@value='false')">
-				<div id="image{@nodeID}">
-					<div class="zoomImage" id="wrap{util:replace(@nodeID, '.', '_')}" style="position:relative; width: {$screenImageWidth}px; height: {$screenImageHeight}px;">
-						<div id="small{util:replace(@nodeID, '.', '_')}" style="position:relative; width: {$screenImageWidth}px; height: {$screenImageHeight}px;">
-							<!--<gsf:image type="screen"/>-->
-							<xsl:call-template name="customScreenImage"/>
-						</div>
-						<div id="mover{util:replace(@nodeID, '.', '_')}" style="border: 1px solid green; position: absolute; top: 0; left: 0; width: 598px; height: 598px; overflow: hidden; z-index: 100; background: white; display: none;">
-							<div id="overlay{util:replace(@nodeID, '.', '_')}" style="width: 600px; height: 600px; position: absolute; top: 0; left: 0; z-index: 200;">
-								<xsl:text> </xsl:text>
-							</div>
-							<div id="large{util:replace(@nodeID, '.', '_')}" style="position: relative; width: {$imageWidth}px; height: {$imageHeight}px;">
-								<gsf:image type="source"/>
-							</div>
-						</div>
-					</div>
-					<script type="text/javascript">
-						<xsl:text disable-output-escaping="yes">
-							{
-								var nodeID = "</xsl:text><xsl:value-of select="@nodeID"/><xsl:text disable-output-escaping="yes">";
-								nodeID = nodeID.replace(/\./g, "_");
-
-								var bigHeight = </xsl:text><xsl:value-of select="$imageHeight"/><xsl:text disable-output-escaping="yes">;
-								var smallHeight = </xsl:text><xsl:value-of select="$screenImageHeight"/><xsl:text disable-output-escaping="yes">;
-
-								var multiplier = bigHeight / smallHeight;
-
-								$("#wrap" + nodeID).anythingZoomer({
-									smallArea: "#small" + nodeID,
-									largeArea: "#large" + nodeID,
-									zoomPort: "#overlay" + nodeID,
-									mover: "#mover" + nodeID,
-									expansionSize:50,  
-									speedMultiplier:multiplier   
-								});
-
-								$("#zoomOptions input").attr("checked", false);
-								$("#zoomOptions").css("display", null);
-							}
-						</xsl:text>
-					</script>
-				</div>
-			</xsl:when>
-			<xsl:otherwise>
-				<!-- this is where -->
-				<div id="image{@nodeID}">
-					<xsl:attribute name="style">
-						<xsl:choose>
-							<xsl:when test="/page/pageRequest/paramList/param[@name = 'view']/@value = 'text'">
-								<xsl:text>display:none;</xsl:text>
-							</xsl:when>
-							<xsl:otherwise>
-								<xsl:text>display:block;</xsl:text>
-							</xsl:otherwise>
-						</xsl:choose>
-						<xsl:text>float:left;</xsl:text>
-					</xsl:attribute>
-					<xsl:call-template name="sectionImage"/>
-					<xsl:text> </xsl:text>
-				</div>
-				<div style="float:right; width:50%; margin-right:50px;">
-					<xsl:variable name="editable">
-						<xsl:choose>
-							<xsl:when test="/page/pageRequest/userInformation">
-								<xsl:text>editable</xsl:text>
-							</xsl:when>
-							<xsl:otherwise>
-								<xsl:text> </xsl:text>
-							</xsl:otherwise>
-						</xsl:choose>
-					</xsl:variable>
-					<script type="text/javascript" src="interfaces/{$interface_name}/js/direct-edit.js"><xsl:text> </xsl:text></script>
-					<xsl:call-template name="init-direct-edit"/>
-					<xsl:if test="metadataList/metadata[@name='dc.Title'] or metadataList/metadata[@name='dc.Subject'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
-						<table id="meta{@nodeID}" style="width:100%;">
-							<xsl:if test="metadataList/metadata[@name='dc.Title'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
-								<tr>
-									<xsl:choose>
-										<xsl:when test="(/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
-											<td style="width:25%;" class="metaTableCellName">dc.Title</td>
-										</xsl:when>
-										<xsl:otherwise>
-											<td style="width:25%;" class="metaTableCellName">Title</td>
-										</xsl:otherwise>
-									</xsl:choose>
-									<td class="metaTableCell {$editable}">
-										<xsl:choose>
-											<xsl:when test="metadataList/metadata[@name='dc.Title']">
-												<xsl:value-of disable-output-escaping="yes" select="metadataList/metadata[@name='dc.Title']"/>
-											</xsl:when>
-											<xsl:otherwise>
-												<xsl:text>[No Title]</xsl:text>
-											</xsl:otherwise>
-										</xsl:choose>
-									</td>
-								</tr>
-							</xsl:if>
-							<xsl:if test="metadataList/metadata[@name='dc.Subject'] or (/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
-								<tr>
-									<xsl:choose>
-										<xsl:when test="(/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true')">
-											<td style="width:25%;" class="metaTableCellName">dc.Subject</td>
-										</xsl:when>
-										<xsl:otherwise>
-											<td style="width:25%;" class="metaTableCellName">Subject</td>
-										</xsl:otherwise>
-									</xsl:choose>
-									<td class="metaTableCell {$editable}">
-										<xsl:choose>
-											<xsl:when test="metadataList/metadata[@name='dc.Subject']">
-												<xsl:value-of disable-output-escaping="yes" select="metadataList/metadata[@name='dc.Subject']"/>
-											</xsl:when>
-											<xsl:otherwise>
-												<xsl:text>[No Subject]</xsl:text>
-											</xsl:otherwise>
-										</xsl:choose>
-									</td>
-								</tr>
-							</xsl:if>
-						</table>
-					</xsl:if>
-					<xsl:if test="/page/pageRequest/userInformation and /page/pageRequest/userInformation/@editEnabled = 'true'">
-						<button id="quickSaveButton">Save Changes</button>
-						<script type="text/javascript">
-							<xsl:text disable-output-escaping="yes">
-								$(window).load(function()
-								{
-									$("#quickSaveButton").click(save);
-								});
-							</xsl:text>
-						</script>
-					</xsl:if>
-				</div>
-				<div style="clear:both;"><xsl:text> </xsl:text></div>
-			</xsl:otherwise>
-		</xsl:choose>
-	</xsl:template>
-	
-	<!-- custom screen image template so we can add "toAnnotate" class to each paged image-->
-	<xsl:template name="customScreenImage" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-		
-		<gsf:variable name="screenImageWidth" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"><gsf:metadata name="ScreenWidth"/></gsf:variable>
-		<gsf:variable name="screenImageHeight" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"><gsf:metadata name="ScreenHeight"/></gsf:variable>
-		<gsf:variable name="imageWidth" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"><gsf:metadata name="ImageWidth"/></gsf:variable>
-		<gsf:variable name="imageHeight" xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"><gsf:metadata name="ImageHeight"/></gsf:variable>
-
-		<xsl:variable name="ScreenName">Screen</xsl:variable>
-		
-		<gsf:link type="source">
-		  <img style="border: 1px solid #000;">
-			<xsl:attribute name="src">
-				<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
-				<xsl:text>/index/assoc/</xsl:text>
-				<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/document/metadataList/metadata[@name = 'assocfilepath']"/>
-				<xsl:text>/</xsl:text>
-				<xsl:value-of disable-output-escaping="yes" select="(.//metadataList)[last()]/metadata[@name = $ScreenName]"/>
-			</xsl:attribute>
-		  </img>
-		</gsf:link>
-	</xsl:template>
-
-</xsl:stylesheet>